=== docs/source/requirements.txt ===
#
# This file is autogenerated by pip-compile with python 3.7
# To update, run:
#
#    pip-compile
#
alabaster==0.7.12
    # via sphinx
babel==2.9.1
    # via sphinx
breathe==4.28.0
    # via -r requirements.in
certifi==2021.10.8
    # via requests
charset-normalizer==2.0.12
    # via requests
docutils==0.16
    # via
    #   -r requirements.in
    #   breathe
    #   m2r2
    #   sphinx
    #   sphinx-rtd-theme
idna==3.3
    # via requests
imagesize==1.3.0
    # via sphinx
jinja2==3.0.3
    # via
    #   -r requirements.in
    #   readthedocs-sphinx-ext
    #   sphinx
m2r2==0.3.1
    # via -r requirements.in
markupsafe==2.1.1
    # via jinja2
mistune==0.8.4
    # via
    #   -r requirements.in
    #   m2r2
packaging==21.3
    # via sphinx
pygments==2.11.2
    # via sphinx
pyparsing==3.0.7
    # via packaging
pytz==2022.1
    # via babel
readthedocs-sphinx-ext==2.1.4
    # via -r requirements.in
requests==2.27.1
    # via
    #   readthedocs-sphinx-ext
    #   sphinx
six==1.16.0
    # via breathe
snowballstemmer==2.2.0
    # via sphinx
sphinx==3.5.3
    # via
    #   -r requirements.in
    #   breathe
    #   sphinx-rtd-theme
sphinx-rtd-theme==0.5.2
    # via -r requirements.in
sphinxcontrib-applehelp==1.0.2
    # via sphinx
sphinxcontrib-devhelp==1.0.2
    # via sphinx
sphinxcontrib-htmlhelp==2.0.0
    # via sphinx
sphinxcontrib-jsmath==1.0.1
    # via sphinx
sphinxcontrib-qthelp==1.0.3
    # via sphinx
sphinxcontrib-serializinghtml==1.1.5
    # via sphinx
urllib3==1.26.9
    # via requests
