=== debian/changelog ===
hipsolver (5.5.1-8) unstable; urgency=medium

  * autopkgtest: Switch test runner over to official rocm-test-launcher
    rocm-test-launcher is now provided by pkg-rocm-tools.

 -- Christian Kastner <ckk@debian.org>  Tue, 25 Feb 2025 09:57:49 +0100

hipsolver (5.5.1-7) unstable; urgency=medium

  * autopkgtest: Replace rocm-testhelper with rocm-test-launcher

 -- Christian Kastner <ckk@debian.org>  Sun, 20 Oct 2024 13:10:56 +0200

hipsolver (5.5.1-6) unstable; urgency=medium

  * autopkgtest: Convert to use of rocm-testhelper
    rocm-testhelper is embedded for evaluation purposes; it will be made
    available separately soon.
  * autopkgtest: Save GTest results as artifact

 -- Christian Kastner <ckk@debian.org>  Wed, 16 Oct 2024 19:15:25 +0200

hipsolver (5.5.1-5) unstable; urgency=medium

  [ Christian Kastner ]
  * Shift version of Breaks+Replaces for -dev to -doc move (Closes: #1067501)

  [ Cordell Bloor ]
  * d/control: update Build-Depends to rocm-device-libs-17
  * Add d/p/0009-hipsolver-use-hipblas-enums.patch to enable opt-in forward
    compatibility with the ROCm 6.0 API
  * Update metadata for patches forwarded upstream:
    - d/p/0004-spellcheck.patch
    - d/p/0006-public-link-hip.patch
    - d/p/0007-drop-f16c-instructions.patch
    - d/p/0008-remove-immintrin-header.patch

 -- Cordell Bloor <cgmb@slerp.xyz>  Sun, 14 Apr 2024 01:25:27 -0600

hipsolver (5.5.1-4) unstable; urgency=medium

  [ Christian Kastner ]
  * autopkgtest: Rename test to generic 'upstream-binaries'

  [ Cordell Bloor ]
  * Reduce architectures to amd64, arm64, ppc64el
  * Update upstream URLs
  * Use openblas as reference implementation for autopkgtests
  * Add d/p/0005-fix-unitary-generator-info-tests.patch to
    backport upstream fix for incorrect tests
  * Move examples from -dev package to -doc package
  * Add d/p/0006-public-link-hip.patch to include hip::host in the hipsolver
    interface link libraries
  * Add 0007-drop-f16c-instructions.patch and
    0008-remove-immintrin-header.patch to fix build on arm64 and ppc64el
  * d/gbp.conf: ensure use of pristine-tar

 -- Cordell Bloor <cgmb@slerp.xyz>  Thu, 21 Mar 2024 22:27:02 -0600

hipsolver (5.5.1-3) unstable; urgency=medium

  * autopkgtest: Save dmesg and amdgpu_firmware_info as artifacts
  * autopkgtest: Explicit names for Test-Command tests
  * Add myself to Uploaders

 -- Christian Kastner <ckk@debian.org>  Thu, 23 Nov 2023 22:46:56 +0100

hipsolver (5.5.1-2) unstable; urgency=medium

  * Migrate to unstable.

 -- Cordell Bloor <cgmb@slerp.xyz>  Sat, 28 Oct 2023 07:54:28 -0600

hipsolver (5.5.1-1) experimental; urgency=medium

  * Initial release. (Closes: #1023098)

 -- Cordell Bloor <cgmb@slerp.xyz>  Fri, 13 Oct 2023 02:46:21 -0600
